{
 "metadata": {
  "name": "",
  "signature": "sha256:715d7d72c30c6f1cf7da025e43a7c11728abc2b19ab8a6c09ad2281eefe9133e"
 },
 "nbformat": 3,
 "nbformat_minor": 0,
 "worksheets": [
  {
   "cells": [
    {
     "cell_type": "heading",
     "level": 1,
     "metadata": {},
     "source": [
      "Chapter 13: Data Structures and Applications in c++"
     ]
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Program Source Code 13.1, page no: 415"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "(SORTEDASCENDING,SORTEDDESCENDING,UNSORTED) = (0,1,2)    #enum declared\n",
      "\n",
      "INSERT_AT_END = -1\n",
      "INSERT_SORT_ASCENDING = -2\n",
      "INSERT_SORT_DESCENDING = -3\n",
      "\n",
      "class NODE:               #class declared\n",
      "    \n",
      "    def __init__(self,d=None):         #constructor\n",
      "        self.__data = d\n",
      "        self.__next = None\n",
      "        \n",
      "    def __del__(self):                #destructor\n",
      "        self.purge()\n",
      "        \n",
      "    def search(self,d):\n",
      "        \n",
      "        if self.__data == d:\n",
      "            return self\n",
      "        \n",
      "        elif self.__next == None:\n",
      "            return None\n",
      "        \n",
      "        else:\n",
      "            return self.__next.search(d)\n",
      "        \n",
      "    def remove(self,d):             #remove function\n",
      "        \n",
      "        n = NODE()       #NODE *n\n",
      "        \n",
      "        if self.__data == d:\n",
      "            return self.__next\n",
      "        \n",
      "        else:\n",
      "            \n",
      "            if not self.__next == None:\n",
      "                n = self.__next.remove(d)\n",
      "                \n",
      "                if not n==self.__next:\n",
      "                    del self.__next\n",
      "            return self\n",
      "    \n",
      "    def insertAtEnd(self,n):                #insert function\n",
      "        \n",
      "        if self.__next == None:\n",
      "            self.__next = n\n",
      "            \n",
      "        else:\n",
      "            self.__next.insertAtEnd(n)\n",
      "            \n",
      "        return False\n",
      "    \n",
      "    \n",
      "    def insert(self,n,pos):                    #insert function\n",
      "        \n",
      "        if pos == INSERT_AT_END:\n",
      "            self.insertAtEnd(n)\n",
      "            \n",
      "        elif pos == INSERT_SORT_ASCENDING:\n",
      "            \n",
      "            if (((pos == INSERT_SORT_ASCENDING)and(n.__data<self.__data)) or ((pos == INSERT_SORT_DESCENDING)and(n.__data>self.__data))):\n",
      "                n.__next = self\n",
      "                return True\n",
      "                \n",
      "            else:\n",
      "                \n",
      "                if self.__next == None:\n",
      "                    self.__next = n\n",
      "                    \n",
      "                else:\n",
      "                    \n",
      "                    if self.__next.insert(n,pos) == True:\n",
      "                        self.__next = n\n",
      "                        \n",
      "                        \n",
      "        elif pos == INSERT_SORT_DESCENDING:\n",
      "            \n",
      "            if (((pos == INSERT_SORT_ASCENDING)and(n.__data<self.__data)) or ((pos == INSERT_SORT_DESCENDING)and(n.__data>self.__data))):\n",
      "                n.__next = self\n",
      "                return True\n",
      "                \n",
      "            else:\n",
      "                \n",
      "                if self.__next == None:\n",
      "                    self.__next = n\n",
      "                    \n",
      "                else:\n",
      "                    \n",
      "                    if self.__next.insert(n,pos) == True:\n",
      "                        self.__next = n\n",
      "                        \n",
      "        else:\n",
      "            \n",
      "            if pos == 0:\n",
      "                n.__next = self\n",
      "                return True\n",
      "            \n",
      "            else:\n",
      "                \n",
      "                if self.__next == None:\n",
      "                    self.__next = n\n",
      "                    \n",
      "                else:\n",
      "                    if self.__next.insert(n,pos-1) == True:\n",
      "                        self.__next = n\n",
      "                        \n",
      "        return False\n",
      "    \n",
      "    def Print(self):               #print function\n",
      "        print self.__data,'->',\n",
      "        \n",
      "        if self.__next == None:\n",
      "            print 'NULL'\n",
      "        else:\n",
      "            self.__next.Print()\n",
      "            \n",
      "    def purge(self):                #purge function\n",
      "        \n",
      "        if not self.__next == None:\n",
      "            del self.__next\n",
      "            self.__next = None\n",
      "            \n",
      "    \n",
      "class LINKEDLIST:                   #class declared\n",
      "    \n",
      "    def __init__(self,Ord = UNSORTED):                  #constructor\n",
      "        \n",
      "        self.__header = NODE()\n",
      "        self.__order = Ord\n",
      "        \n",
      "    def __del__(self):                  #destructor\n",
      "        self.purge()\n",
      "        \n",
      "        \n",
      "    def search(self,d):                        #search \n",
      "        \n",
      "        if (not self.__header == None) and (not self.__header.search(d) == None):\n",
      "            return True\n",
      "        return False\n",
      "    \n",
      "    def remove(self,d):             #remove\n",
      "        \n",
      "        n = NODE()\n",
      "        \n",
      "        if not self.__header == None:\n",
      "            n = self.__header.remove(d)\n",
      "            \n",
      "            if not n==self.__header:\n",
      "                del self.__header\n",
      "                self.__header = n\n",
      "    \n",
      "    \n",
      "    def insert(self,d,pos = UNSORTED):\n",
      "        \n",
      "        if self.__order == SORTEDASCENDING:      #considering all cases and position\n",
      "            pos = INSERT_SORT_ASCENDING\n",
      "            \n",
      "        elif self.__order == SORTEDDESCENDING:\n",
      "            pos = INSERT_SORT_DESCENDING\n",
      "            \n",
      "        n=[None]*d\n",
      "            \n",
      "        n = NODE(d)\n",
      "        \n",
      "        if self.__header == None or self.__header.insert(n,pos) == True:\n",
      "            self.__header = n\n",
      "            \n",
      "    \n",
      "    def Print(self):                              #printing the list\n",
      "        print '---------------------------------'\n",
      "        \n",
      "        if self.__header._NODE__next == None:\n",
      "            print 'Empty Linked List.....'\n",
      "            \n",
      "        else:\n",
      "            self.__header.Print()\n",
      "            \n",
      "        print '----------------------------------'\n",
      "        \n",
      "        \n",
      "    def purge(self):\n",
      "        \n",
      "        if not self.__header == None:\n",
      "            del self.__header\n",
      "            self.__header = None\n",
      "            \n",
      " #variable declaration\n",
      "            \n",
      "print 'Empty LinkedListCreated'\n",
      "\n",
      "aList = LINKEDLIST()\n",
      "bList = LINKEDLIST(SORTEDASCENDING)\n",
      "cList = LINKEDLIST(SORTEDDESCENDING)\n",
      "\n",
      "aList.Print()\n",
      "\n",
      "print 'Inserting 3, 5, 2 to be inserted at end'\n",
      "\n",
      "aList.insert(3, INSERT_AT_END)\n",
      "aList.insert(5, INSERT_AT_END)\n",
      "aList.insert(2, INSERT_AT_END)\n",
      "\n",
      "aList.Print()\n",
      "\n",
      "print 'Inserting 3, 5, 2 to be inserted in sort ascending order'\n",
      "\n",
      "bList.insert(3)\n",
      "bList.insert(5)\n",
      "bList.insert(2)\n",
      "\n",
      "bList.Print()\n",
      "\n",
      "\n",
      "print 'Inserting 3, 5, 2 to be inserted in sort descending order'\n",
      "\n",
      "cList.insert(3)\n",
      "cList.insert(5)\n",
      "cList.insert(2)\n",
      "\n",
      "cList.Print()\n",
      "\n",
      "\n",
      "print 'Inserting 3, 5, 2 to be inserted always (like stack) at the beginning'\n",
      "aList.purge()\n",
      "aList.insert(3,0)\n",
      "aList.insert(5,0)\n",
      "aList.insert(2,0)\n",
      "aList.Print()\n",
      "\n",
      "\n",
      "print 'Inserting 3, 5, 2 to be inserted at position 0, 1, 1 respectively'\n",
      "aList.purge()\n",
      "aList.insert(3,0)\n",
      "aList.insert(5,1)\n",
      "aList.insert(2,1)\n",
      "aList.Print()"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "Empty LinkedListCreated\n",
        "---------------------------------\n",
        "Empty Linked List.....\n",
        "----------------------------------\n",
        "Inserting 3, 5, 2 to be inserted at end\n",
        "---------------------------------\n",
        "None -> 3 -> 5 -> 2 -> NULL\n",
        "----------------------------------\n",
        "Inserting 3, 5, 2 to be inserted in sort ascending order\n",
        "---------------------------------\n",
        "None -> 2 -> 3 -> 5 -> NULL\n",
        "----------------------------------\n",
        "Inserting 3, 5, 2 to be inserted in sort descending order\n",
        "---------------------------------\n",
        "5 -> 3 -> 2 -> None -> NULL\n",
        "----------------------------------\n",
        "Inserting 3, 5, 2 to be inserted always (like stack) at the beginning\n",
        "---------------------------------\n",
        "2 -> 5 -> 3 -> NULL\n",
        "----------------------------------\n",
        "Inserting 3, 5, 2 to be inserted at position 0, 1, 1 respectively\n",
        "---------------------------------\n",
        "3 -> 2 -> 5 -> NULL\n",
        "----------------------------------\n"
       ]
      }
     ],
     "prompt_number": 1
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Program Source Code 13.2, page no: 423"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "(FALSE, TRUE)= (0,1)          #enum declaration\n",
      "\n",
      "class Employee:         #class employee declared\n",
      "    def __init__(self, nm=None, sal=0):          #constructor\n",
      "        self.__name=None\n",
      "        if(nm!=None):\n",
      "            self.__name=[]\n",
      "            \n",
      "            self.__name.append(nm)\n",
      "            nm=self.__name\n",
      "        self.__salary=sal\n",
      "            \n",
      "    def __del__(self):                     #destructor\n",
      "        if(self.__name!=None):\n",
      "           del self.__name\n",
      "        \n",
      "    def display(self):                  #display function\n",
      "        if(self.__name==None):\n",
      "            print 'No Name available for employee'\n",
      "            print ''\n",
      "        else:\n",
      "            print 'Name of the employee: ',self.__name\n",
      "            \n",
      "            \n",
      "class Manager(Employee):              #derived class declared\n",
      "    def __init__(self, nm, sal):                      #constructor\n",
      "         Employee.__init__(self,nm,sal)\n",
      "            \n",
      "    def __del__(self):             #destructor\n",
      "        pass\n",
      "    def display(self):\n",
      "        Employee.display(self)\n",
      "        print 'Employee type: Manager'\n",
      "        \n",
      "class Programmer(Employee):              #derived class declared\n",
      "    def __init__(self, nm, sal,lang):              #constructor\n",
      "        Employee.__init__(self,nm,sal)\n",
      "        self.__language=None\n",
      "        if lang!=None:\n",
      "            self.__language=[len(lang)+1]\n",
      "            self.__language=lang\n",
      "            \n",
      "    def __del__(self):                 #destructor\n",
      "        pass\n",
      "            \n",
      "    def display(self):             #display\n",
      "        Employee.display(self)\n",
      "        print 'Employee type: programmer'\n",
      "        if self.__language==None:\n",
      "            print 'Language known: None specific'\n",
      "        else:\n",
      "            print 'language known: ',self.__language\n",
      "        \n",
      "        \n",
      "class Secretary(Employee):                  #derived class declared\n",
      "    def __init__(self, nm, sal,Isteno,typespeed):  #constructor\n",
      "        Employee.__init__(self,nm,sal)\n",
      "        self.__steno=Isteno\n",
      "        self.__Typingspeed=typespeed\n",
      "        \n",
      "    def __del__(self):                 #destructor\n",
      "        pass\n",
      "        \n",
      "    def display(self):                #displaying the characteristic of secretary\n",
      "        Employee.display(self)\n",
      "        print 'Employee type: Secretary'\n",
      "        if self.__steno== False:\n",
      "            print 'Cannot perform job of a steno'\n",
      "        else:\n",
      "            print 'can perform job of a steno'\n",
      "        print 'typing speed is: ',self.__Typingspeed\n",
      "        \n",
      "        \n",
      "        \n",
      " #objects declared and initialised \n",
      "        \n",
      "e=[Employee() for j in range(5)]\n",
      "e[0]=Manager('A. Pal',1000)\n",
      "e[1]=Programmer('D.Ghosh',6000,'C++')\n",
      "e[2]=Programmer('R.Das',5000,'Java')\n",
      "e[3]=Secretary('S.Ray',3000,False,40)\n",
      "e[4]=Secretary('A.Chatterjee',2500,True,50)\n",
      "for i in range(5):\n",
      "    e[i].display()\n",
      "del e[0]"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "Name of the employee:  ['A. Pal']\n",
        "Employee type: Manager\n",
        "Name of the employee:  ['D.Ghosh']\n",
        "Employee type: programmer\n",
        "language known:  C++\n",
        "Name of the employee:  ['R.Das']\n",
        "Employee type: programmer\n",
        "language known:  Java\n",
        "Name of the employee:  ['S.Ray']\n",
        "Employee type: Secretary\n",
        "Cannot perform job of a steno\n",
        "typing speed is:  40\n",
        "Name of the employee:  ['A.Chatterjee']\n",
        "Employee type: Secretary\n",
        "can perform job of a steno\n",
        "typing speed is:  50\n"
       ]
      }
     ],
     "prompt_number": 2
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [],
     "language": "python",
     "metadata": {},
     "outputs": []
    }
   ],
   "metadata": {}
  }
 ]
}